
module Common.PackedString where

import Data.Word (Word8)
import Foreign.ForeignPtr(ForeignPtr, mallocForeignPtrArray)
import Common.MMap (mmap)
import System.IO.Unsafe (unsafePerformIO)

data PackedString = PS !(ForeignPtr Word8) !Int !Int

nilPS :: PackedString
nilPS = unsafePerformIO $ do fp <- mallocForeignPtrArray 1
                             return $ PS fp 0 0

mmapFilePS :: FilePath -> PackedString
mmapFilePS f = unsafePerformIO $ do (fp,l) <- mmap f
                                    return $ PS fp 0 l

