
{-# OPTIONS -fffi -fglasgow-exts #-}

module Tests.Ptr.FindSpace.BarelyHaskell (main) where

import Common.PackedString (PackedString(PS), mmapFilePS)
import Utils.Timer (timeIO)

import Prelude hiding (Int, IO)

import Data.Word (Word8)
import Foreign.ForeignPtr (withForeignPtr)
import Foreign.Ptr (plusPtr)
import GHC.Exts (
    Ptr(Ptr), Int(I#), word2Int#, (==#), State#, RealWorld,
    Addr#, plusAddr#, minusAddr#, eqAddr#, readWord8OffAddr#,
    )
import GHC.IOBase (IO(IO))
import System.Environment (getArgs)

main :: IO ()
main = do [dir, test] <- getArgs
          timeIO "BarelyHaskell" $ foo $ mmapFilePS (dir ++ "/data_" ++ test)

foo :: PackedString -> IO Int
foo (PS x s l) = withForeignPtr x $ \p-> first_space (p `plusPtr` s) l

first_space :: Ptr Word8 -> Int -> IO Int
first_space (Ptr start) l@(I# l') =
    do let end :: Addr#
           end = start `plusAddr#` l'
           f :: Addr# -> State# RealWorld -> (# State# RealWorld, Int #)
           f p st =
               if p `eqAddr#` end
               then (# st, l #)
               else case readWord8OffAddr# p 0# st of
                        (# st', c #) ->
                            if word2Int# c ==# 32#
                            then (# st', I# (p `minusAddr#` start) #)
                            else f (p `plusAddr#` 1#) st'
       IO (f start)

