
{-# OPTIONS -fffi -fglasgow-exts #-}

module Tests.Ptr.FindSpace.Haskell (main) where

import Common.PackedString (PackedString(PS), mmapFilePS)
import Utils.Timer (timeIO)

import Data.Word (Word8)
import Foreign.ForeignPtr (withForeignPtr)
import Foreign.Ptr (Ptr, plusPtr, minusPtr)
import Foreign.Storable (peek)
import System.Environment (getArgs)

main :: IO ()
main = do [dir, test] <- getArgs
          timeIO "Haskell" $ foo $ mmapFilePS (dir ++ "/data_" ++ test)

foo :: PackedString -> IO Int
foo (PS x s l) = withForeignPtr x $ \p-> first_space (p `plusPtr` s) l

first_space :: Ptr Word8 -> Int -> IO Int
first_space start l =
    do let end :: Ptr Word8
           end = start `plusPtr` l
           f :: Ptr Word8 -> IO Int
           f p = if p == end
                 then return l
                 else do c <- peek p
                         if c == 32
                           then return (p `minusPtr` start)
                           else f (p `plusPtr` 1)
       f start

