
{-# OPTIONS -fffi #-}

module Tests.Ptr.FindWhite.Base (main) where

import Common.PackedString (PackedString(PS), mmapFilePS)
import Utils.Timer (timeIO)

import Data.Word (Word8)
import Foreign.ForeignPtr (withForeignPtr)
import Foreign.Ptr (Ptr, plusPtr)
import System.Environment (getArgs)

main :: IO ()
main = do [dir, test] <- getArgs
          timeIO "Base" $ foo $ mmapFilePS (dir ++ "/data_" ++ test)

foo :: PackedString -> IO Int
foo (PS x s l) = withForeignPtr x $ \p-> first_white (p `plusPtr` s) l

foreign import ccall unsafe "first_white.h first_white"
    first_white :: Ptr Word8 -> Int -> IO Int

