
{-# OPTIONS -fffi -fglasgow-exts #-}

module Tests.Ptr.Reverse.BarelyHaskell (main) where

import Common.PackedString (PackedString(PS), mmapFilePS)
import Utils.Timer (timeIO)

import Prelude hiding (Int, IO)

import Data.Word (Word8)
import Foreign.ForeignPtr (withForeignPtr)
import Foreign.Marshal.Alloc (allocaBytes)
import Foreign.Ptr (plusPtr)
import GHC.Exts (
    Ptr(Ptr), Int(I#), Int#, (==#), (-#), State#,
    RealWorld, Addr#, plusAddr#, readWord8OffAddr#, writeWord8OffAddr#,
    )
import GHC.IOBase (IO(IO))
import System.Environment (getArgs)

main :: IO ()
main = do [dir, test] <- getArgs
          timeIO "BarelyHaskell" $ foo $ mmapFilePS (dir ++ "/data_" ++ test)

foo :: PackedString -> IO ()
foo (PS x s l) = withForeignPtr x $ \p_from ->
                 allocaBytes l $ \p_to ->
                 rev l (p_from `plusPtr` s) (p_to `plusPtr` (l - 1))

rev :: Int -> Ptr Word8 -> Ptr Word8 -> IO ()
rev (I# len) (Ptr from) (Ptr to) =
    do let fun :: Int# -> Addr# -> Addr# -> State# RealWorld
               -> (# State# RealWorld, () #)
           fun l f t st = if l ==# 0#
                          then (# st, () #)
                          else case readWord8OffAddr# f 0# st of
                               (# st', c #) ->
                                   case writeWord8OffAddr# t 0# c st' of
                                   st'' -> fun (l -# 1# )
                                               (f `plusAddr#` 1# )
                                               (t `plusAddr#` -1# )
                                               st''
       IO (fun len from to)

