
{-# OPTIONS -fffi #-}

module Tests.Ptr.Reverse.Base (main) where

import Common.PackedString (PackedString(PS), mmapFilePS)
import Utils.Timer (timeIO)

import Data.Word (Word8)
import Foreign.ForeignPtr (withForeignPtr)
import Foreign.Marshal.Alloc (allocaBytes)
import Foreign.Ptr (Ptr, plusPtr)
import System.Environment (getArgs)

main :: IO ()
main = do [dir, test] <- getArgs
          timeIO "Base" $ foo $ mmapFilePS (dir ++ "/data_" ++ test)

foo :: PackedString -> IO ()
foo (PS x s l) = withForeignPtr x $ \p_from ->
                 allocaBytes l $ \p_to ->
                 rev l (p_from `plusPtr` s) (p_to `plusPtr` (l - 1))

foreign import ccall unsafe "rev.h rev"
    rev :: Int -> Ptr Word8 -> Ptr Word8 -> IO ()

