
{-# OPTIONS -fffi -fglasgow-exts #-}

module Tests.Ptr.Reverse.Haskell2 (main) where

import Common.PackedString (PackedString(PS), mmapFilePS)
import Utils.Timer (timeIO)

import Data.Word (Word8)
import Foreign.ForeignPtr (withForeignPtr)
import Foreign.Marshal.Alloc (allocaBytes)
import Foreign.Ptr (Ptr, plusPtr)
import Foreign.Storable (peek, poke)
import System.Environment (getArgs)

main :: IO ()
main = do [dir, test] <- getArgs
          timeIO "Haskell" $ foo $ mmapFilePS (dir ++ "/data_" ++ test)

foo :: PackedString -> IO ()
foo (PS x s l) = withForeignPtr x $ \p_from ->
                 allocaBytes l $ \p_to ->
                 rev l (p_from `plusPtr` s) (p_to `plusPtr` (l - 1))

rev :: Int -> Ptr Word8 -> Ptr Word8 -> IO ()
rev len from to = do let fun l f t = if l == 0
                                     then return ()
                                     else do c <- peek f
                                             poke t c
                                             fun (l - 1) (f `plusPtr` 1)
                                                         (t `plusPtr` (-1))
                     fun len from to

